<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TransportSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TransportSupplier extends AbstractStructArrayBase
{
    /**
     * The TransportSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TransportSupplier[]
     */
    public $TransportSupplier;
    /**
     * Constructor method for ArrayOfJP_TransportSupplier
     * @uses ArrayOfJP_TransportSupplier::setTransportSupplier()
     * @param \StructType\JP_TransportSupplier[] $transportSupplier
     */
    public function __construct(array $transportSupplier = array())
    {
        $this
            ->setTransportSupplier($transportSupplier);
    }
    /**
     * Get TransportSupplier value
     * @return \StructType\JP_TransportSupplier[]|null
     */
    public function getTransportSupplier()
    {
        return $this->TransportSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportSupplierForArrayConstraintsFromSetTransportSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TransportSupplierTransportSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransportSupplierTransportSupplierItem instanceof \StructType\JP_TransportSupplier) {
                $invalidValues[] = is_object($arrayOfJP_TransportSupplierTransportSupplierItem) ? get_class($arrayOfJP_TransportSupplierTransportSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_TransportSupplierTransportSupplierItem), var_export($arrayOfJP_TransportSupplierTransportSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportSupplier property can only contain items of type \StructType\JP_TransportSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportSupplier[] $transportSupplier
     * @return \ArrayType\ArrayOfJP_TransportSupplier
     */
    public function setTransportSupplier(array $transportSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($transportSupplierArrayErrorMessage = self::validateTransportSupplierForArrayConstraintsFromSetTransportSupplier($transportSupplier))) {
            throw new \InvalidArgumentException($transportSupplierArrayErrorMessage, __LINE__);
        }
        $this->TransportSupplier = $transportSupplier;
        return $this;
    }
    /**
     * Add item to TransportSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportSupplier $item
     * @return \ArrayType\ArrayOfJP_TransportSupplier
     */
    public function addToTransportSupplier(\StructType\JP_TransportSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TransportSupplier) {
            throw new \InvalidArgumentException(sprintf('The TransportSupplier property can only contain items of type \StructType\JP_TransportSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TransportSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TransportSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TransportSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TransportSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TransportSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportSupplier
     */
    public function getAttributeName()
    {
        return 'TransportSupplier';
    }
}
